#! /bin/sh

DIR="/var/local/lib/netams"
ZONA=<>

CAT="/bin/cat"
TELNET="/usr/bin/telnet"
SLEEP="/bin/sleep"
FGREP="/bin/fgrep"
GREP="/bin/grep"
CUT="/bin/cut"
SORT="/bin/sort"
CMP="/usr/bin/cmp"
MV="/bin/mv"
JOIN="/usr/bin/join"
SED="/bin/sed"
SERVICE="/sbin/service"
RM="/bin/rm"
PS="/bin/ps"
NETAMSCTL="/usr/sbin/netamsctl"
DIG="/usr/bin/dig"
DIFF="/usr/bin/diff"
AWK="/bin/awk"
MKTEMP="/bin/mktemp"
RM="/bin/rm"

#  .
if ! $PS -C netams|$FGREP -q 'netams'; then
	echo "No run netams!"
	exit
fi

cd $DIR

#   
$MV -f dns.new dns.old 2>/dev/null || :
$DIG $ZONA AXFR | \
	$AWK '($3 == "IN") && ($4 == "A") && ($5 != "192.168.0.1") { 
		split($1, ip, ".")
		print tolower(ip[1]) "|" $5}' | \
	$SORT > dns.new
	
if $DIFF -qiEbB dns.old dns.new 2>/dev/null 1>/dev/null ; then
#		echo No 1
		exit
fi

#echo Yes 1

# tmp

TMPDIR=`$MKTEMP -d "/tmp/netams_autounit.XXXXXXXXXX"`

trap "$RM -rf $TMPDIR" 0 1 2 3 15

$CUT -d"|" -s -f 1 dns.new > $TMPDIR/name.dns  2>/dev/null &

$CUT -d"|" -s -f 2 dns.new > $TMPDIR/ip.dns  2>/dev/null &

wait

$NETAMSCTL "show units" | \
	$CUT -d'|' -s -f 1,3,7 | \
	$AWK '($1 == "host") && ($6 ~ "192.168.0.[0-9]*" ) { 
		print $3 "|" $6 }' > $TMPDIR/netams.old

(
	$FGREP -v -f $TMPDIR/name.dns $TMPDIR/netams.old | \
		$FGREP -f $TMPDIR/ip.dns | \
		$SED 's/192\.168\.0\./192.168.10./'
	$FGREP -v -f $TMPDIR/netams.old dns.new
) > $TMPDIR/netams.set

if test ! -s $TMPDIR/netams.set ; then
#		echo No 2
		$RM -rf $TMPDIR
		exit
fi

#echo Yes 2

#  

. /etc/.netamsctl.rc

(
	echo
	$SLEEP 2
	echo "$login"
	echo "$password"
	echo
	echo "service processor 0"
	$AWK 'BEGIN { FS = "|" }
		{ print "unit host name " $1 " ip " $2 " ds-list 2 parent lanhosts acct-policy all-www all-ip"}' \
		$TMPDIR/netams.set
	echo
	echo
	echo "save"
	$SLEEP 5
	echo "exit"
) | \
	$TELNET $host $port 2>/dev/null >/dev/null

$RM -rf $TMPDIR

exit
